Union (Apache Ant API)
Description: declaration: package: org.apache.tools.ant.types.resources, class: Union

# Class Union

java.lang.Object
org.apache.tools.ant.ProjectComponent
org.apache.tools.ant.types.DataType
org.apache.tools.ant.types.resources.BaseResourceCollectionContainer
org.apache.tools.ant.types.resources.Union

All Implemented Interfaces:
  `Cloneable, Iterable<Resource>, ResourceCollection, AppendableResourceCollection`

public class Union extends BaseResourceCollectionContainer
ResourceCollection representing the union of multiple nested ResourceCollections.

Since:
  Ant 1.7

- ## Field Summary

  ### Fields inherited from class DataType

  `checked, ref`
  Modifier and Type
  Field
  Description
  `protected boolean`
  `checked`
  Deprecated.
  since 1.7.
  `protected Reference`
  `ref`
  Deprecated.
  since 1.7.

  ### Fields inherited from class ProjectComponent

  `description, location, project`
  Modifier and Type
  Field
  Description
  `protected String`
  `description`
  Deprecated.
  since 1.6.x.
  `protected Location`
  `location`
  Deprecated.
  since 1.6.x.
  `protected Project`
  `project`
  Deprecated.
  since 1.6.x.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Union()`
  Default constructor.
  `Union(Project project)`
  Create a new Union.
  `Union(Project project, ResourceCollection rc)`
  Convenience constructor.
  `Union(ResourceCollection rc)`
  Convenience constructor.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected Set<Resource>`
  `getAllResources()`
  Get the unified set of contained Resources.
  `protected Collection<String>`
  `getAllToStrings()`
  Get a collection of strings representing the unified resource set (strings may duplicate).
  `protected Collection<Resource>`
  `getCollection()`
  Unify the contained Resources.
  `protected <T> Collection<T>`
  `getCollection(boolean asString)`
  Deprecated.
  `static Union`
  `getInstance(ResourceCollection rc)`
  Static convenience method to union an arbitrary set of Resources.
  `String[]`
  `list()`
  Returns all Resources in String format.
  `Resource[]`
  `listResources()`
  Convenience method.

  ### Methods inherited from class BaseResourceCollectionContainer

  `add, addAll, clear, clone, dieOnCircularReference, getResourceCollections, isCache, isFilesystemOnly, iterator, setCache, size, toString`
  Modifier and Type
  Method
  Description
  `void`
  `add(ResourceCollection c)`
  Add a ResourceCollection to the container.
  `void`
  `addAll(Collection<? extends ResourceCollection> c)`
  Add the Collection of ResourceCollections to the container.
  `void`
  `clear()`
  Clear the container.
  `Object`
  `clone()`
  Implement clone.
  `protected void`
  `dieOnCircularReference(Stack<Object> stk, Project p)`
  Overrides the version of DataType to recurse on all DataType child elements that may have been added.
  `final List<ResourceCollection>`
  `getResourceCollections()`
  Get the nested ResourceCollections.
  `boolean`
  `isCache()`
  Learn whether to cache collections.
  `boolean`
  `isFilesystemOnly()`
  Fulfill the ResourceCollection contract.
  `final Iterator<Resource>`
  `iterator()`
  Fulfill the ResourceCollection contract.
  `void`
  `setCache(boolean b)`
  Set whether to cache collections.
  `int`
  `size()`
  Fulfill the ResourceCollection contract.
  `String`
  `toString()`
  Format this BaseResourceCollectionContainer as a String.

  ### Methods inherited from class DataType

  `checkAttributesAllowed, checkChildrenAllowed, circularReference, dieOnCircularReference, dieOnCircularReference, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getDataTypeName, getRefid, invokeCircularReferenceCheck, isChecked, isReference, noChildrenAllowed, pushAndInvokeCircularReferenceCheck, setChecked, setRefid, tooManyAttributes`
  Modifier and Type
  Method
  Description
  `protected void`
  `checkAttributesAllowed()`
  check that it is ok to set attributes, i.e that no reference is defined
  `protected void`
  `checkChildrenAllowed()`
  check that it is ok to add children, i.e that no reference is defined
  `protected BuildException`
  `circularReference()`
  Creates an exception that indicates the user has generated a loop of data types referencing each other.
  `protected void`
  `dieOnCircularReference()`
  Convenience method.
  `protected void`
  `dieOnCircularReference(Project p)`
  Convenience method.
  `protected <T> T`
  `getCheckedRef()`
  Deprecated.
  use getCheckedRef(Class)
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName, Project project)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Project p)`
  Deprecated.
  use getCheckedRef(Class)
  `protected String`
  `getDataTypeName()`
  Gets as descriptive as possible a name used for this datatype instance.
  `Reference`
  `getRefid()`
  get the reference set on this object
  `static void`
  `invokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected boolean`
  `isChecked()`
  The flag that is used to indicate that circular references have been checked.
  `boolean`
  `isReference()`
  Has the refid attribute of this element been set?
  `protected BuildException`
  `noChildrenAllowed()`
  Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.
  `static void`
  `pushAndInvokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected void`
  `setChecked(boolean checked)`
  Set the flag that is used to indicate that circular references have been checked.
  `void`
  `setRefid(Reference ref)`
  Set the value of the refid attribute.
  `protected BuildException`
  `tooManyAttributes()`
  Creates an exception that indicates that refid has to be the only attribute if it is set.

  ### Methods inherited from class ProjectComponent

  `getDescription, getLocation, getProject, log, log, setDescription, setLocation, setProject`
  Modifier and Type
  Method
  Description
  `String`
  `getDescription()`
  Returns the description of the current action.
  `Location`
  `getLocation()`
  Returns the file/location where this task was defined.
  `Project`
  `getProject()`
  Returns the project to which this component belongs.
  `void`
  `log(String msg)`
  Logs a message with the default (INFO) priority.
  `void`
  `log(String msg, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `setDescription(String desc)`
  Sets a description of the current action.
  `void`
  `setLocation(Location location)`
  Sets the file/location where this task was defined.
  `void`
  `setProject(Project project)`
  Sets the project object of this component.

  ### Methods inherited from class Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface Iterable

  `forEach, spliterator`

  ### Methods inherited from interface ResourceCollection

  `isEmpty, stream`
  Modifier and Type
  Method
  Description
  `default boolean`
  `isEmpty()`
  Learn whether this `ResourceCollection` is empty.
  `default Stream<? extends Resource>`
  `stream()`
  Return a `Stream` over this `ResourceCollection`.

- ## Constructor Details

  - ### Union

    public Union()
    Default constructor.

  - ### Union

    public Union(Project project)
    Create a new Union.
    Parameters:
      `project` - owning Project

  - ### Union

    public Union(ResourceCollection rc)
    Convenience constructor.
    Parameters:
      `rc` - the ResourceCollection to add.

  - ### Union

    public Union(Project project, ResourceCollection rc)
    Convenience constructor.
    Parameters:
      `project` - owning Project
      `rc` - the ResourceCollection to add.

- ## Method Details

  - ### getInstance

    public static Union getInstance(ResourceCollection rc)
    Static convenience method to union an arbitrary set of Resources.
    Parameters:
      `rc` - a ResourceCollection.
    Returns:
      a Union.

  - ### list

    public String[] list()
    Returns all Resources in String format. Provided for convenience in implementing Path.
    Returns:
      String array of Resources.

  - ### listResources

    public Resource[] listResources()
    Convenience method.
    Returns:
      Resource[]

  - ### getCollection

    protected Collection<Resource> getCollection()
    Unify the contained Resources.
    Specified by:
      `getCollection` in class `BaseResourceCollectionContainer`
    Returns:
      a Collection of Resources.

  - ### getCollection

    @Deprecated protected <T> Collection<T> getCollection(boolean asString)
    Deprecated.
    Unify the contained Resources.
    Type Parameters:
      `T` - resource type
    Parameters:
      `asString` - indicates whether the resulting Collection should contain Strings instead of Resources.
    Returns:
      a Collection of Resources.

  - ### getAllToStrings

    protected Collection<String> getAllToStrings()
    Get a collection of strings representing the unified resource set (strings may duplicate).
    Returns:
      Collection<String>

  - ### getAllResources

    protected Set<Resource> getAllResources()
    Get the unified set of contained Resources.
    Returns:
      Set<Resource>